export default function taskManager(tasks: Array<() => Promise<void>>, maxConcurrentTasks: number): Promise<void> {
  return new Promise((resolve, reject) => {
    const remainingTasks = tasks;
    //const currentlyRunningTasks: Array<Promise<void>> = [];

    const startNewTask = () => {
      if (remainingTasks.length === 0) {
        return resolve();
      }

      const curTask = remainingTasks.pop() as () => Promise<void>;
      const curPromise = curTask();
      //currentlyRunningTasks.push(curPromise);
      curPromise.then(() => {
        return startNewTask();
      });
    };

    for (let i = 0; i < maxConcurrentTasks; i += 1) {
      startNewTask();
    }
  });
}
